import {
  MenuFoldOutlined, MenuUnfoldOutlined,
  DatabaseFilled
} from '@ant-design/icons';
import { Button, Layout, Menu, Tabs } from 'antd';
import 'antd/dist/antd.css';
import React, {useRef} from 'react';


import './App.less';
import ChartsCount from './ChartsCount';
import TableData from './TableData';
import TabsRoute from './Router';
import { Link, Route, Router, HashRouter, Switch, useHistory } from 'react-router-dom';

const { TabPane } = Tabs;
const { Header, Content, Footer, Sider } = Layout;

class App extends React.Component {

  constructor(props) {
    super(props)
    this.state = {
      platform: "openrec",
      collapsed: false,
      tkey: "content_table",
      location: null,
    }
  }

 

  toggleCollapsed = () => {
    this.setState({
      collapsed: !this.state.collapsed,
    });
  };

  changePlatform = (p) => {
    // this.setState({ platform: p });
    // if (this.chartscount && this.chartscount.state.platform !== p) {
    //   this.chartscount.changePlatform(p)
    // }
    // this.tabledata.changePlatform(p);
  }

  render() {
    return (
      <HashRouter>
        
      <Layout>
        <Sider
          trigger={null}
          collapsible
          collapsed={this.state.collapsed}
          inlineCollapsed={this.state.collapsed}
        >
          <Button type="primary" onClick={this.toggleCollapsed} style={{ background: '#6739b6', width: "100%", colorRendering: "optimizeSpeed" }}>
            {React.createElement(this.state.collapsed ? MenuUnfoldOutlined : MenuFoldOutlined)}
          </Button>
          <Menu theme="dark" mode="inline" defaultSelectedKeys={['1']}
            defaultOpenKeys={['sub1']}
          >
            <Menu.Item key="openrec" icon={<DatabaseFilled />} onClick={(e) => { this.changePlatform(e.key); }}  >
              openrec
                </Menu.Item>
            <Menu.Item key="twitcasting" icon={<DatabaseFilled />} onClick={(e) => { this.changePlatform(e.key);; }}  >
              twitcasting
                </Menu.Item>
            <Menu.Item key="twitch" icon={<DatabaseFilled />} onClick={(e) => { this.changePlatform(e.key); }}  >
              twitch
                </Menu.Item>
          </Menu>
        </Sider>
        <Layout>
          
          <Header style={{ background: '#000', padding: "0" }}>

          </Header>
    
          <Content ref="content" style={{ margin: '0 8px' }}>
          <Switch>
            <Tabs
              onChange={(e) => {
                const history = useHistory();

                const { platform } = this.state;
                this.setState({ key: e })
                
                switch (e) {
                  case "content_table":
                    history.push("#/data")
                    // this.props.history.push("#/data")
                    if (this.refs.ctable) {
                      this.refs.ctable.changePlatform(platform);
                    }
                    break;
                  case "tag_count":
                    history.push("#/count")
                    // this.props.history.push("#/count")
                    if (this.refs.tcharts) {
                      this.refs.tcharts.changePlatform(platform);
                    }
                    break
                  default:
                    break;
                }

              }} >

            


            

              <TabPane tab="数据表格" key="content_table">
                  <Route path="/data"  render={()=>{
                    return <TableData platform={this.state.platform}  ></TableData>
                  }} ></Route>
              </TabPane>

              <TabPane tab="tag统计" key="tag_count">
                <Route path="/count"  render={()=>{
                  return <ChartsCount platform={this.state.platform} ></ChartsCount>
                }} ></Route>
              </TabPane>
              
            </Tabs>
            </Switch>
          </Content>

          <Footer style={{ textAlign: 'center' }}>
            Intimate ©2020 Created by eson
            </Footer>
        </Layout>
      </Layout>
      </HashRouter>         
    );
  }
}

// ReactDOM.render(<App />, mountNode);

export default App;